package net.t2code.opsecurity.check;

import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.language.Languages;
import net.t2code.opsecurity.config.permissionWhitelist.PermissionWhitelist;
import net.t2code.opsecurity.events.Events;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.BungeeSenderReceiver;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.commands.T2C_Cmd;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import org.bukkit.Bukkit;
import org.bukkit.entity.Player;

import java.util.List;
import java.util.Map;

public class PermissionCheck {
    public static Boolean onCheck(Player player, Boolean join, String debug) {
        if (!(boolean) PermissionWhitelist.VALUES.enable.getValue()) return false;
        for (String perm : (List<String>) PermissionWhitelist.VALUES.permissions.getValue()) {
            if (!player.hasPermission(perm)) return false;
            T2C_Debug.debug(Main.getPlugin(), "[" + debug + "] check Permission: " + perm);
            if (permWhitelist(player, debug)) return false;
            Bukkit.getScheduler().runTask(Main.getPlugin(), new Runnable() {
                @Override
                public void run() {
                    execute(player, join, perm, debug);
                }
            });
            return true;
        }
        return false;
    }

    private static void execute(Player player, Boolean join, String perm, String debug) {
        if (join)
            T2C_Send.console("[" + debug + "]" + Languages.VALUES.permissionWhitelistNotifyKick.getValue().toString().replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
        if ((boolean) Config.VALUES.notifyJoinWarning.getValue() && join) {
            if ((boolean) Config.VALUES.notifyBungee.getValue()) {
                BungeeSenderReceiver.sendToBungee(Languages.VALUES.permissionWhitelistNotifyOnJoin.getValue().toString().replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
            } else
                Events.notifyPlayer(Languages.VALUES.permissionWhitelistNotifyOnJoin.getValue().toString().replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[uuid]", String.valueOf(player.getUniqueId())));
        }

        if ((boolean) PermissionWhitelist.VALUES.playerWithPermissionKick.getValue()) {
            if ((boolean) Config.VALUES.kickCustomCommand.getValue()) {
                T2C_Cmd.console(Config.VALUES.kickCommand.getValue().toString().replace("[perm]", perm).replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[reason]", Languages.VALUES.permissionWhitelistKick.getValue().toString()));
            } else player.kickPlayer(Languages.VALUES.permissionWhitelistKick.getValue().toString());
            T2C_Send.console("[" + debug + "]" + Languages.VALUES.permissionWhitelistNotifyKick.getValue().toString().replace("[player]",
                    player.getName()).replace("[perm]", perm).replace("[uuid]", String.valueOf(player.getUniqueId())));
        }
        if ((boolean) PermissionWhitelist.VALUES.customCommandsEnable.getValue()) {
            for (String cmd : (List<String>) PermissionWhitelist.VALUES.customCommandsCommands.getValue()) {
                T2C_Cmd.console(cmd.replace("[player]", player.getName()).replace("%player_name%", player.getName()).replace("[perm]", perm));
            }
        }
    }

    public static Boolean permWhitelist(Player player, String debug) {

        for (Map.Entry<String, PlayerObject> playerObject : PlayerCache.getPermissionHashMap().entrySet()) {
            T2C_Debug.debug(Main.getPlugin(), "[" + debug + "] --------- " + player.getName() + " ---------");
            T2C_Debug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist playerObject Name: " + playerObject.getValue().playerName);
            T2C_Debug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist Player Name: " + player.getName());
            T2C_Debug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist playerObject UUID: " + playerObject.getValue().uuid);
            T2C_Debug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist Player UUID: " + player.getUniqueId().toString().replace("-", ""));
            if (playerObject.getValue().playerName.equals(player.getName()) && playerObject.getValue().uuid.equals(player.getUniqueId().toString().replace("-", ""))) {
                T2C_Debug.debug(Main.getPlugin(), "[" + debug + "] permWhitelist Player on list!");
                T2C_Debug.debug(Main.getPlugin(), "");
                return true;
            } else T2C_Debug.debug(Main.getPlugin(), "");
        }
        return false;
    }
}
