package net.t2code.opsecurity.command;

import net.t2code.opsecurity.util.Util;
import net.t2code.opsecurity.check.OpCheck;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.language.Languages;
import net.t2code.opsecurity.config.opWhitelist.OPWhitelist;
import net.t2code.opsecurity.config.permissionWhitelist.PermissionWhitelist;
import net.t2code.opsecurity.system.Main;
import net.t2code.opsecurity.system.Permissions;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import org.bukkit.Bukkit;
import org.bukkit.command.CommandSender;
import org.bukkit.entity.Player;

public class Commands {

    public static void help(CommandSender sender) {
        if (!sender.hasPermission(Permissions.help)) {
            T2C_Send.sender(sender, Languages.VALUES.noPermissionForOpSec.getValue().toString());
            return;
        }
        //todo to language file

        sender.sendMessage(Util.getPrefix() + " §8----- §2OP§4Security §chelp §8-----");
        sender.sendMessage(Util.getPrefix());
        sender.sendMessage(Util.getPrefix() + " §8'§b/opsecurity reload§8' §eReload the Plugin.");
        sender.sendMessage(Util.getPrefix() + " §8'§b/opsecurity help§8' §eOpens this help.");
        sender.sendMessage(Util.getPrefix() + " §8'§b/opsecurity info§8' §eCall the info about §2OP§4Security§e.");
        sender.sendMessage(Util.getPrefix());
        sender.sendMessage(Util.getPrefix() + " §8----------------------------");
    }

    public static void mainCommand(CommandSender sender) {
        if ((boolean) Config.VALUES.onlyOPcanUseThePlugin.getValue()) {
            if (!sender.isOp()) {
                sender.sendMessage(Util.getPrefix() + "§cOnly OPs can use OPSecurity!");
                return;
            }
        }
        if (sender.hasPermission(Permissions.help)) {
            help(sender);
        } else {
            sender.sendMessage(Util.getPrefix() + " §cYou do not have permission for OPSecurity! §7<" + Permissions.help + ">");
        }
    }

    public static void reload(CommandSender sender) {
        if (!sender.hasPermission(Permissions.reload)) {
            sender.sendMessage(Util.getPrefix() + "§cYou do not have permission for OPSecurity! §7<" + Permissions.reload + ">");
            return;
        }
        if (sender instanceof Player) {
            Player player = (Player) sender;
            if ((boolean) Config.VALUES.onlyOPcanUseThePlugin.getValue()) {
                String debug = T2C_Debug.debugCode();
                if (!OpCheck.opWhitelist(player, debug)) {
                    sender.sendMessage(Util.getPrefix() + " §4You are not on the Whitelist!"); // todo
                    return;
                }
            }
            T2C_Send.player(player, Languages.VALUES.reloadStart.getValue().toString());
        }
        if (sender instanceof Player) T2C_Send.player((Player) sender, Languages.VALUES.reloadEnd.getValue().toString());
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §6Plugin reload...");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        // Load.onLoad(Main.getPlugin(),Main.getAutor(),Main.getVersion());
        Config.set(true);
        Languages.set(true);
        OPWhitelist.set(true);
        PermissionWhitelist.set(true);
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + " §2Plugin successfully reloaded.");
        Bukkit.getConsoleSender().sendMessage(Util.getPrefix() + "§8-------------------------------");
    }

    public static void info(CommandSender sender) {
        if (!sender.hasPermission(Permissions.info)) {
            sender.sendMessage(Util.getPrefix() + "§cYou do not have permission for OPSecurity! §7<" + Permissions.info + ">");
            return;
        }
        T2C_Template.sendInfo(sender, Main.getPlugin(), Util.getSpigotID(), Util.getDiscord(), Util.getInfoText());
    }
}
