// This class was created by JaTiTV.

package net.t2code.opsecurity.config.config;

import net.t2code.opsecurity.system.Main;
import net.t2code.opsecurity.util.Util;
import net.t2code.t2codelib.SPIGOT.api.minecraftVersion.T2C_McVersion;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.Sound;

import java.io.File;
import java.util.HashMap;
import java.util.List;

public class Config {

    public enum VALUES implements T2C_ConfigItem {

        language("plugin.language", "english", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du die Sprache des Plugins einstellen."));
                    put(T2C_LanguageEnum.english, List.of("Here you can set the language of the plugin."));
                }}),
        onlyOPcanUseThePlugin("plugin.onlyOPcanUseThePlugin", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du festlegen, dass nur Spieler mit OP die Befehle des Plugins nutzen können."));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify that only players with OP can use the commands of the plugin."));
                }}),

        updateCheckOnJoin("plugin.updateCheck.onJoin", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Mit dieser Option kannst du festlegen, ob Spieler mit der Berechtigung 't2c.opsecurity.updatemsg' beim Beitritt eine Update-Nachricht erhalten, wenn ein Update für das Plugin verfügbar ist."));
                    put(T2C_LanguageEnum.english, List.of("In this option you can set if players with the permission 't2c.opsecurity.updatemsg' will get an update message on join when an update for the plugin is available."));
                }}),
        updateCheckSeePreReleaseUpdates("plugin.updateCheck.seePreReleaseUpdates", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("In dieser Option kannst du einstellen, ob du Beta- und Snapshot-Versionen in der Update-Prüfung erhalten und anzeigen möchtest."));
                    put(T2C_LanguageEnum.english, List.of("In this option you can set whether you want to receive and display beta and snapshot versions in the update check."));
                }}),
        updateCheckTimeInterval("plugin.updateCheck.timeInterval", 60, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Mit dieser Option kannst du das Zeitintervall in Minuten festlegen, in dem Aktualisierungen überprüft werden sollen."));
                    put(T2C_LanguageEnum.english, List.of("In this option you can set the time interval in minutes in which updates should be checked."));
                }}),

        checkOnJoin("check.onJoin.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Aktiviere die Prüfung, ob der Spieler berechtigt ist, wenn er dem Server beitritt."));
                    put(T2C_LanguageEnum.english, List.of("Activate the checks whether the player is authorised when joining the player."));
                }}),
        checkOnInteract("check.onInteract.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Aktiviere die Prüfung, ob der Spieler für Spielerinteraktionen autorisiert ist."));
                    put(T2C_LanguageEnum.english, List.of("Activate the checks whether the player is authorised for player interactions."));
                }}),
        checkOnCommand("check.onCommand.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Aktiviere die Prüfung, ob der Spieler berechtigt ist, wenn er einen Befehl ausführt."));
                    put(T2C_LanguageEnum.english, List.of("Activate the checks whether the player is authorised when the player executes a command."));
                }}),
        checkOnCommandWhitelist("check.onCommand.whitelist", List.of("command 1", "command 2"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du Befehle angeben, für die die Prüfung nicht durchgeführt wird."));
                    put(T2C_LanguageEnum.english, List.of("Here you can specify commands for which the check is not carried out."));
                }}),
        checkOnChat("check.onChat.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Aktiviere die Überprüfung, ob der Spieler autorisiert ist, wenn er eine Chat-Nachricht schreibt."));
                    put(T2C_LanguageEnum.english, List.of("Activate the checks whether the player is authorised when the player writes a chat message."));
                }}),
        checkTimerEnable("check.timer.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Aktiviere die Überprüfung aller Spieler in einem Zeitintervall."));
                    put(T2C_LanguageEnum.english, List.of("Activate the check of all players in a time interval."));
                }}),
        checkTimerRefreshInSec("check.timer.refreshInSec", 60, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier stellst du die Sekunden ein, mit denen die Prüfung in einem Zeitintervall durchgeführt wird."));
                    put(T2C_LanguageEnum.english, List.of("Here you set the seconds with which the check is carried out in a time interval."));
                }}),
        kickCustomCommand("kick.customCommand.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Soll ein separater Kick-Befehl für den Kick verwendet werden? Zum Beispiel, wenn du ein eigenes Verbotssystem verwenden."));
                    put(T2C_LanguageEnum.english, List.of("Should a separate kick command be used for the kick? For example, if you use your own ban system."));
                }}),
        kickCommand("kick.customCommand.command", "minecraft:kick [player] [reason]", true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kannst du den benutzerdefinierten Kick-Befehl einstellen."));
                    put(T2C_LanguageEnum.english, List.of("This is where you set the user-defined kick command."));
                }}),
        notifyJoinWarning("notify.warn.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Sollen Spieler mit der Berechtigung 't2c.opsecurity.notify' gewarnt werden, wenn ein Spieler entdeckt wird, der nicht berechtigt ist, mit OP / einer Permission auf dem Server zu sein."));
                    put(T2C_LanguageEnum.english, List.of("Should players with the permission 't2c.opsecurity.notify' be warned if a player is detected who is not authorised to be on the server with OP / a permission."));
                }}),
        notifyBungee("notify.allProxyPlayer.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Sollen die Warnungen an das gesamte Netzwerk (true) oder nur an den einzelnen Server (false) gesendet werden.", "Damit diese Funktion funktioniert, muss die T2CodeLib auf deinem Proxy vorhanden sein und in deren Config die API für T2C-OPSecurity aktiviert werden!"));
                    put(T2C_LanguageEnum.english, List.of("Should the warnings be sent on the entire network (true) or only on the individual server (false).", "For this function to work, the T2CodeLib must be present on your proxy and the API for T2C-OPSecurity must be activated in its config!"));
                }}),
        notifySoundEnable("notify.soundEnable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Soll ein Sound abgespielt werden, bei einer Benachrichtigung?"));
                    put(T2C_LanguageEnum.english, List.of("Should a sound be played during the warnings?"));
                }}),
        notifySoundValue("notify.sound", sound(), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Welcher Sound soll bei Benachrichtigung abgespielt werden?"));
                    put(T2C_LanguageEnum.english, List.of("Which sound should be played during the warnings?"));
                }}),
        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return language.path;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }


    public static void set(boolean isReload) {
        T2C_ConfigWriter.createConfig(Util.getPrefix(), new File(Main.getPath(), "config.yml"), VALUES.values(), isReload, Util.getConfigLogo());
    }


    private static Sound sound() {
        if (T2C_McVersion.isMc1_8()) {
            return Sound.valueOf("NOTE_PIANO");
        } else if (T2C_McVersion.isMc1_9() || T2C_McVersion.isMc1_10() || T2C_McVersion.isMc1_11() || T2C_McVersion.isMc1_12()) {
            return Sound.valueOf("BLOCK_NOTE_HARP");
        } else return Sound.valueOf("BLOCK_NOTE_BLOCK_HARP");
    }

}
