package net.t2code.opsecurity.config.config;

import net.t2code.opsecurity.util.Util;
import net.t2code.opsecurity.config.opWhitelist.OPWhitelist;
import net.t2code.opsecurity.config.permissionWhitelist.PermissionWhitelist;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.Main;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;

public class Converter {
    private static YamlConfiguration yamlConfigurationOld;
    private static YamlConfiguration opYml;
    private static YamlConfiguration permYml;

    public static void convert() {
        Path pathOld = Paths.get("plugins/OPSecurity/config.yml");
        Path pathNew = Paths.get(Main.getPath() + "/config.yml");
        if (Files.exists(pathNew) && !Files.isDirectory(pathNew)) {
            return;
        }
        if (Files.exists(pathOld) && !Files.isDirectory(pathOld)) {

            File configOld = new File("plugins/OPSecurity/config.yml");
            yamlConfigurationOld = YamlConfiguration.loadConfiguration(configOld);
            File opConfig = new File(Main.getPath(), "opWhitelist.yml");
            opYml = YamlConfiguration.loadConfiguration(opConfig);
            File permConfig = new File(Main.getPath(), "permissionWhitelist.yml");
            permYml = YamlConfiguration.loadConfiguration(permConfig);


            setConfig("Plugin.language", Config.VALUES.language);
            setConfig("Plugin.OnlyOPcanUseThePlugin", Config.VALUES.onlyOPcanUseThePlugin);
            setConfig("Check.OnJoin", Config.VALUES.checkOnJoin);
            setConfig("Check.OnInteract", Config.VALUES.checkOnInteract);
            setConfig("Check.OnCommand", Config.VALUES.checkOnCommand);
            setConfig("Check.OnChat", Config.VALUES.checkOnChat);
            setConfig("Check.Timer.Enable", Config.VALUES.checkTimerEnable);
            setConfig("Check.Timer.RefreshTime_inSec", Config.VALUES.checkTimerRefreshInSec);
            setConfig("Kick.Command", Config.VALUES.kickCommand);
            setConfig("Notify.JoinWarn.Enable", Config.VALUES.notifyJoinWarning);
            setConfig("Notify.Sound.Enable", Config.VALUES.notifySoundEnable);
            setConfig("Notify.Sound.Sound", Config.VALUES.notifySoundValue);

            setOPWhitelist("OP_Whitelist.Enable", OPWhitelist.VALUES.enable);
            setOPWhitelist("OP_Whitelist.PlayerMustBeOnlineToOp", OPWhitelist.VALUES.playerMustBeOnlineToOp);
            setOPWhitelist("OP_Whitelist.noOpPlayerDeop.Enable", OPWhitelist.VALUES.noOpPlayerDeopEnable);
            setOPWhitelist("OP_Whitelist.noOpPlayerDeop.PlayerSendMessage", OPWhitelist.VALUES.noOpPlayerDeopPlayerSendMessage);
            setOPWhitelist("OP_Whitelist.noOpPlayerKick.Enable", OPWhitelist.VALUES.noOpPlayerKickEnable);
            setOPWhitelist("OP_Whitelist.customCommands.Enable", OPWhitelist.VALUES.customCommandsEnable);
            setOPWhitelist("OP_Whitelist.customCommands.Commands", OPWhitelist.VALUES.customCommandsCommands);


            if (yamlConfigurationOld.contains("OP_Whitelist.Whitelist")) {
                ArrayList<PlayerObject> opWhitelist = new ArrayList<>();
                for (String key : yamlConfigurationOld.getConfigurationSection("OP_Whitelist.Whitelist").getKeys(false)) {
                    PlayerObject player = new PlayerObject(key,
                            yamlConfigurationOld.getString("OP_Whitelist.Whitelist." + key + ".UUID").replace("-", ""));
                    opWhitelist.add(player);
                }

                for (PlayerObject playerObject : opWhitelist) {
                    PLAYERENUM.name.path = "opWhitelist.whitelist.KEY.name".replace("KEY", playerObject.playerName);
                    PLAYERENUM.name.value = playerObject.playerName;

                    PLAYERENUM.uuid.path = "opWhitelist.whitelist.KEY.uuid".replace("KEY", playerObject.playerName);
                    PLAYERENUM.uuid.value = playerObject.uuid;

                    T2C_ConfigWriter.createConfig(Util.getPrefix(),new File(Main.getPath(), "opWhitelist.yml"), PLAYERENUM.values(),false, Util.getConfigLogo());
                }
            }


            setPermissionWhitelist("Permission_Whitelist.Enable", PermissionWhitelist.VALUES.enable);
            setPermissionWhitelist("Permission_Whitelist.Permissions", PermissionWhitelist.VALUES.permissions);
            setPermissionWhitelist("Permission_Whitelist.PlayerWhithPermission_kick", PermissionWhitelist.VALUES.playerWithPermissionKick);
            setPermissionWhitelist("Permission_Whitelist.customCommands.Enable", PermissionWhitelist.VALUES.customCommandsEnable);
            setPermissionWhitelist("Permission_Whitelist.customCommands.Commands", PermissionWhitelist.VALUES.customCommandsCommands);


            ArrayList<PlayerObject> permWhitelist = new ArrayList<>();
            for (String key : yamlConfigurationOld.getConfigurationSection("Permission_Whitelist.Whitelist").getKeys(false)) {
                PlayerObject player = new PlayerObject(key,
                        yamlConfigurationOld.getString("Permission_Whitelist.Whitelist." + key + ".UUID").replace("-", ""));
                permWhitelist.add(player);
            }
            for (PlayerObject playerObject : permWhitelist) {
                permYml.set("permissionWhitelist.whitelist.KEY.name".replace("KEY", playerObject.playerName), playerObject.playerName);
                permYml.set("permissionWhitelist.whitelist.KEY.uuid".replace("KEY", playerObject.playerName), playerObject.uuid);
            }

            try {
                opYml.save(opConfig);
            } catch (IOException e) {
                e.printStackTrace();
            }
            try {
                permYml.save(permConfig);
            } catch (IOException e) {
                e.printStackTrace();
            }
        }
    }

    public static void convertCheck() {
        File config = new File(Main.getPath(), "config.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);


        if (!yamlConfiguration.contains("check.onJoin.enable")) {
            Boolean onJoin = yamlConfiguration.getBoolean("check.onJoin");
            T2C_Debug.debugmsg(Main.getPlugin(), "onJoin = " + onJoin);
            yamlConfiguration.set("check.onJoin.enable", onJoin);
        }
        if (!yamlConfiguration.contains("check.onInteract.enable")) {
            Boolean onInteract = yamlConfiguration.getBoolean("check.onInteract");
            T2C_Debug.debugmsg(Main.getPlugin(), "onInteract = " + onInteract);
            yamlConfiguration.set("check.onInteract.enable", onInteract);
        }
        if (!yamlConfiguration.contains("check.onCommand.enable")) {
            Boolean onCommand = yamlConfiguration.getBoolean("check.onCommand");
            T2C_Debug.debugmsg(Main.getPlugin(), "onCommand = " + onCommand);
            yamlConfiguration.set("check.onCommand.enable", onCommand);
        }
        if (!yamlConfiguration.contains("check.onChat.enable")) {
            Boolean onChat = yamlConfiguration.getBoolean("check.onChat");
            T2C_Debug.debugmsg(Main.getPlugin(), "onChat = " + onChat);
            yamlConfiguration.set("check.onChat.enable", onChat);
        }

        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            throw new RuntimeException(e);
        }
    }

    private static void setConfig(String path, T2C_ConfigItem item) {
        if (yamlConfigurationOld.contains(path)) {
            item.setValue(yamlConfigurationOld.get(path));
        }
    }

    private static void setOPWhitelist(String path, T2C_ConfigItem item) {
        if (yamlConfigurationOld.contains(path)) {
            item.setValue(opYml.get(path));
        }
    }

    private static void setPermissionWhitelist(String path, T2C_ConfigItem item) {
        if (yamlConfigurationOld.contains(path)) {
            item.setValue(permYml.get(path));
        }
    }


    private enum PLAYERENUM implements T2C_ConfigItem {

        name("", "", true, new HashMap<>()),
        uuid("", "", true, new HashMap<>()),

        ;

        private String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        PLAYERENUM(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }


        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return null;
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }
}
