// This class was created by JaTiTV.

package net.t2code.opsecurity.config.opWhitelist;

import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.Main;
import net.t2code.opsecurity.util.Util;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.GameMode;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.HashMap;
import java.util.List;

public class OPWhitelist {

    public enum VALUES implements T2C_ConfigItem {

        enable("opWhitelist.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hiermit aktivierst du die OP-Whitelist."));
                    put(T2C_LanguageEnum.english, List.of("This activates the OP whitelist."));
                }}),
        playerMustBeOnlineToOp("opWhitelist.playerMustBeOnlineToOp", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Wenn diese Option aktiviert ist, muss der Spieler dem OP gegeben werden soll sich auf dem Server befinden.", "Dies gilt auch wenn man einen Spieler per Console OP geben möchte."));
                    put(T2C_LanguageEnum.english, List.of("If this option is activated, the player to whom the OP is to be given must be on the server.", "This also applies if you want to OP a player via console."));
                }}),
        noOpPlayerDeopEnable("opWhitelist.noOpPlayerDeop.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Sollen den Spielern die OP besitzen, die aber nicht auf der Whitelist stehen, OP entfernt bekommen?"));
                    put(T2C_LanguageEnum.english, List.of("Should players who have OP but are not on the whitelist have OP removed?"));
                }}),
        noOpPlayerDeopPlayerSendMessage("opWhitelist.noOpPlayerDeop.playerSendMessage", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Sollen Spieler eine Benachrichtigung erhalten, wenn sie OP entfernt bekommen?"));
                    put(T2C_LanguageEnum.english, List.of("Should players receive a notification when they get OP removed?"));
                }}),
        noOpPlayerKickEnable("opWhitelist.noOpPlayerKick.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier legst du fest ob ein Spieler gekickt werden soll, wenn er OP besitzt und nicht auf der Whitelist steht."));
                    put(T2C_LanguageEnum.english, List.of("Here you determine whether a player should be kicked if he has OP and is not on the whitelist."));
                }}),
        noOpPlayerSetGameModeEnable("opWhitelist.noOpPlayerSetGameMode.enable", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Sollen Spieler, die OP besitzen und nicht auf der Whitelist stehen in einen bestimmten Gamemode gesetzt werden?"));
                    put(T2C_LanguageEnum.english, List.of("Should players who own OP and are not on the whitelist be set to a specific gamemode?"));
                }}),
        noOpPlayerSetGameModeValue("opWhitelist.noOpPlayerSetGameMode.gameMode", GameMode.SURVIVAL, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier legst du den Gamemode fest, in den Spieler gesetzt werden sollen, die OP besitzen und nicht auf der Whitelist stehen."));
                    put(T2C_LanguageEnum.english, List.of("Here you define the game mode in which players who have OP and are not on the whitelist are to be set."));
                }}),
        customCommandsEnable("opWhitelist.customCommands.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Soll ein bestimmter befehl ausgeführt werden, wenn ein Spieler OP hat und nicht auf der Whitelist steht."));
                    put(T2C_LanguageEnum.english, List.of("Should a certain command be executed if a player has OP and is not on the whitelist."));
                }}),
        customCommandsCommands("opWhitelist.customCommands.commands", List.of("kick [player] &4You have op but are not authorized to do so, that's why you were kicked!"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of("Hier kann man Mehrere Commands einfügen, die ausgeführt werden, wenn ein Spieler OP hat und nicht auf der Whitelist steht."));
                    put(T2C_LanguageEnum.english, List.of("Here you can add several commands that are executed when a player has OP and is not on the whitelist."));
                }}),

        playerSection("opWhitelist.whitelist", null, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.german, List.of(
                            "Hier legst du wie im Beispiel die Spieler an, die OP besitzen dürfen.",
                            "Wichtig:",
                            "  Es muss der Spielername und die UUID angegeben werden!",
                            "  Der Spielername muss mit Groß/Kleinschreibung eingefügt werden!",
                            "Die UUID eines Spielers kannst du hier finden: https://mcuuid.net",
                            "Wenn dein Server nicht im OnlineModus ist, werden alle Spieler andere UUIDs erhalten, dann findest du die UUID eines Spielers in deiner Console, wenn der Spieler den Server betritt."
                    ));
                    put(T2C_LanguageEnum.english, List.of(
                            "Here, as in the example, you create the players who are allowed to own OP.",
                            "Important:",
                            "  The player name and the UUID must be entered!",
                            "  The player name must be inserted with upper/lower case!",
                            "You can find the UUID of a player here: https://mcuuid.net",
                            "If your server is not in online mode, all players will receive different UUIDs, then you will find the UUID of a player in your console when the player enters the server."
                    ));
                }}),
        player1name("opWhitelist.whitelist.player1.name", "player1", false, new HashMap<>()),
        player1uuid("opWhitelist.whitelist.player1.uuid", "00000000000000000000000000000000", false, new HashMap<>()),
        player2name("opWhitelist.whitelist.player2.name", "player2", false, new HashMap<>()),
        player2uuid("opWhitelist.whitelist.player2.uuid", "00000000000000000000000000000000", false, new HashMap<>()),
        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return Config.VALUES.language.getValue().toString();
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        File file = new File(Main.getPath(), "opWhitelist.yml");
        T2C_ConfigWriter.createConfig(Util.getPrefix(), file, VALUES.values(), isReload, Util.getConfigLogo());
        getPlayer(file);
    }

    private static void getPlayer(File file) {
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(file);
        for (String key : yamlConfiguration.getConfigurationSection(VALUES.playerSection.getPath()).getKeys(false)) {
            String name = yamlConfiguration.getString(VALUES.playerSection.getPath() + "." + key + ".name");
            String uuid = yamlConfiguration.getString(VALUES.playerSection.getPath() + "." + key + ".uuid").replace("-", "");
            PlayerObject playerObject = new PlayerObject(
                    name,
                    uuid);
            PlayerCache.getOpHashMap().put(name, playerObject);
        }
    }
}
