// This class was created by JaTiTV.

package net.t2code.opsecurity.config.permissionWhitelist;

import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.objects.PlayerCache;
import net.t2code.opsecurity.objects.PlayerObject;
import net.t2code.opsecurity.system.Main;
import net.t2code.opsecurity.util.Util;
import net.t2code.t2codelib.SPIGOT.api.yaml.T2C_ConfigWriter;
import net.t2code.t2codelib.util.T2C_ConfigItem;
import net.t2code.t2codelib.util.T2C_LanguageEnum;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

public class PermissionWhitelist {

    public enum VALUES implements T2C_ConfigItem {

        enable("permissionWhitelist.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of());
                    put(T2C_LanguageEnum.german, List.of());
                }}),
        playerWithPermissionKick("permissionWhitelist.playerWithPermissionKick", true, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of());
                    put(T2C_LanguageEnum.german, List.of());
                }}),
        permissions("permissionWhitelist.permissions", Arrays.asList("*", "t2c.opsecurity.admin"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of());
                    put(T2C_LanguageEnum.german, List.of());
                }}),
        customCommandsEnable("permissionWhitelist.customCommands.enable", false, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of());
                    put(T2C_LanguageEnum.german, List.of());
                }}),
        customCommandsCommands("permissionWhitelist.customCommands.commands", Arrays.asList("lp user [player] permission unset *", "lp user [player] permission unset t2c.opsecurity.admin"), true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of());
                    put(T2C_LanguageEnum.german, List.of());
                }}),

        playerSection("permissionWhitelist.whitelist", null, true,
                new HashMap<>() {{
                    put(T2C_LanguageEnum.english, List.of());
                    put(T2C_LanguageEnum.german, List.of());
                }}),
        player1name("permissionWhitelist.whitelist.player1.name", "player1", false,
                new HashMap<>()),
        player1uuid("permissionWhitelist.whitelist.player1.uuid", "00000000000000000000000000000000", false,
                new HashMap<>()),
        player2name("permissionWhitelist.whitelist.player2.name", "player2", false,
                new HashMap<>()),
        player2uuid("permissionWhitelist.whitelist.player2.uuid", "00000000000000000000000000000000", false,
                new HashMap<>()),

        ;

        private final String path;
        private Object value;
        private final boolean forceSet;
        private final HashMap<T2C_LanguageEnum, List<String>> comments;

        VALUES(String path, Object value, boolean forceSet, HashMap<T2C_LanguageEnum, List<String>> comments) {
            this.path = path;
            this.value = value;
            this.forceSet = forceSet;
            this.comments = comments;
        }

        @Override
        public String getPath() {
            return path;
        }

        @Override
        public Object getValue() {
            return value;
        }

        @Override
        public boolean getForceSet() {
            return forceSet;
        }

        @Override
        public HashMap<T2C_LanguageEnum, List<String>> getComments() {
            return comments;
        }

        @Override
        public String getLanguagePath() {
            return Config.VALUES.language.getValue().toString();
        }

        @Override
        public void setValue(Object newValue) {
            value = newValue;
        }
    }

    public static void set(boolean isReload) {
        File file = new File(Main.getPath(), "permissionWhitelist.yml");
        T2C_ConfigWriter.createConfig(Util.getPrefix(), file, VALUES.values(), isReload, Util.getConfigLogo());
        getPlayer(file);
    }


    private static void getPlayer(File file) {
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(file);
        for (String key : yamlConfiguration.getConfigurationSection(VALUES.playerSection.getPath()).getKeys(false)) {
            String name = yamlConfiguration.getString(VALUES.playerSection.getPath() + "." + key + ".name");
            String uuid = yamlConfiguration.getString(VALUES.playerSection.getPath() + "." + key + ".uuid").replace("-", "");
            PlayerObject playerObject = new PlayerObject(
                    name,
                    uuid);
            PlayerCache.getOpHashMap().put(name, playerObject);
        }
    }
}
