package net.t2code.opsecurity.events;

import net.t2code.opsecurity.util.Util;
import net.t2code.opsecurity.check.OpCheck;
import net.t2code.opsecurity.check.PermissionCheck;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.system.Main;
import net.t2code.opsecurity.system.Permissions;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Send;
import net.t2code.t2codelib.SPIGOT.api.update.T2C_UpdateAPI;
import org.bukkit.Bukkit;
import org.bukkit.Sound;
import org.bukkit.entity.Player;
import org.bukkit.event.EventHandler;
import org.bukkit.event.Listener;
import org.bukkit.event.player.*;

import java.util.List;

public class Events implements Listener {
    public static void notifyPlayer(String msg) {
        if (!(boolean) Config.VALUES.notifyJoinWarning.getValue()) return;
        for (Player notifyPlayer : Bukkit.getOnlinePlayers()) {
            if (!notifyPlayer.hasPermission(Permissions.notify)) continue;
            T2C_Send.player(notifyPlayer, msg);
            if ((boolean) Config.VALUES.notifySoundEnable.getValue()){
                notifyPlayer.playSound(notifyPlayer.getLocation(), Sound.valueOf(Config.VALUES.notifySoundValue.getValue().toString()), 3, 1);
            }
        }
    }

    @EventHandler
    public void CommandSendEvent(PlayerCommandPreprocessEvent event) {
        if (!(boolean) Config.VALUES.checkOnCommand.getValue()) return;
        Player player = event.getPlayer();
        String debug = T2C_Debug.debugCode();

        for (String s : (List<String>) Config.VALUES.checkOnCommandWhitelist.getValue()) {
            if (event.getMessage().startsWith("/" + s)) {
                return;
            }
        }

        if (OpCheck.onCheck(player, false, debug)) {
            if (event.isCancelled()) return;
            event.setCancelled(true);
        }
        String debug2 = T2C_Debug.debugCode();
        if (PermissionCheck.onCheck(player, false, debug2)) {
            if (event.isCancelled()) return;
            event.setCancelled(true);
        }
    }


    @EventHandler
    public void PlayerChatEvent(PlayerChatEvent event) {
        if (!(boolean) Config.VALUES.checkOnChat.getValue()) return;
        Player player = event.getPlayer();
        String debug = T2C_Debug.debugCode();
        if (OpCheck.onCheck(player, false, debug)) {
            if (event.isCancelled()) return;
            event.setCancelled(true);
        }
        String debug2 = T2C_Debug.debugCode();
        if (PermissionCheck.onCheck(player, false, debug2)) {
            if (event.isCancelled()) return;
            event.setCancelled(true);
        }
    }

    @EventHandler
    public void onInteract(PlayerInteractEvent event) {
        if (!(boolean) Config.VALUES.checkOnInteract.getValue()) return;
        Bukkit.getScheduler().runTaskLaterAsynchronously(Main.getPlugin(), new Runnable() {
            @Override
            public void run() {
                Player player = event.getPlayer();
                String debug = T2C_Debug.debugCode();
                if (OpCheck.onCheck(player, false, debug)) {
                    event.setCancelled(true);
                }
                String debug2 = T2C_Debug.debugCode();
                if (PermissionCheck.onCheck(player, false, debug2)) {
                    event.setCancelled(true);
                }
            }
        }, 1L);
    }

    @EventHandler
    public void onJoinCheck(PlayerJoinEvent event) {
        if (!(boolean) Config.VALUES.checkOnJoin.getValue()) return;
        Bukkit.getScheduler().runTaskLaterAsynchronously(Main.getPlugin(), new Runnable() {
            @Override
            public void run() {
                Player player = event.getPlayer();
                String debug = T2C_Debug.debugCode();
                OpCheck.onCheck(player, true, debug);
                String debug2 = T2C_Debug.debugCode();
                PermissionCheck.onCheck(player, true, debug2);
            }
        }, 1L);
    }

    @EventHandler
    public void onJoinEvent(PlayerLoginEvent event) {
        Player player = event.getPlayer();
        T2C_UpdateAPI.join(Main.getPlugin(), Util.getPrefix(), Permissions.updatemsg, player, Util.getSpigotID(), Util.getDiscord());
    }
}
