package net.t2code.opsecurity.system;

import net.t2code.opsecurity.util.Util;
import net.t2code.opsecurity.check.Timer;
import net.t2code.opsecurity.command.CmdExecuter;
import net.t2code.opsecurity.config.config.Config;
import net.t2code.opsecurity.config.config.Converter;
import net.t2code.opsecurity.config.language.Languages;
import net.t2code.opsecurity.config.opWhitelist.OPWhitelist;
import net.t2code.opsecurity.config.permissionWhitelist.PermissionWhitelist;
import net.t2code.opsecurity.events.Events;
import net.t2code.opsecurity.events.OpCommand;
import net.t2code.opsecurity.events.PlugManCommand;
import net.t2code.t2codelib.SPIGOT.api.debug.T2C_Debug;
import net.t2code.t2codelib.SPIGOT.api.messages.T2C_Template;
import net.t2code.t2codelib.SPIGOT.api.register.T2C_Register;
import net.t2code.t2codelib.SPIGOT.api.update.T2C_UpdateAPI;
import net.t2code.t2codelib.SPIGOT.system.config.config.T2C_LibConfig;
import net.t2code.t2codelib.util.T2C_Util;
import org.bukkit.Bukkit;

import java.util.List;
import java.util.logging.Level;

public class Load {

    public static void onLoad(Main plugin, List<String> autor, String version) {
        long long_ = T2C_Template.onLoadHeader(Util.getPrefix(), autor, version, Util.getSpigot(), Util.getDiscord());
        try {
            Converter.convert();
        } catch (Exception ex) {
            plugin.getLogger().log(Level.SEVERE, ex.getMessage());
            ex.printStackTrace();
        }

        Config.set(false);
        Languages.set(false);
        OPWhitelist.set(false);
        PermissionWhitelist.set(false);

        plugin.getCommand("t2c-opsecurity").setExecutor(new CmdExecuter());

        T2C_Register.listener(new OpCommand(), plugin);
        T2C_Register.listener(new PlugManCommand(), plugin);
        T2C_Register.listener(new Events(), plugin);
        if ((boolean) T2C_LibConfig.VALUES.proxy.getValue()) {
            Bukkit.getMessenger().registerOutgoingPluginChannel(plugin, T2C_Util.getPluginChannel_OPSecurity());
            T2C_Debug.debug(plugin, "registerIncomingPluginChannel §e:" + T2C_Util.getPluginChannel_OPSecurity());
        }
        Timer.refreshTimer();
        Permissions.register();
        T2C_UpdateAPI.onUpdateCheck(plugin, Util.getPrefix(), Util.getGit(), Util.getSpigotID(), Util.getDiscord(), (boolean) Config.VALUES.updateCheckOnJoin.getValue(),
                (boolean) Config.VALUES.updateCheckSeePreReleaseUpdates.getValue(), (int) Config.VALUES.updateCheckTimeInterval.getValue());
        Metrics.Bstats(plugin, Util.getBstatsID());
        T2C_Template.onLoadFooter(Util.getPrefix(), long_);
    }
}
